// DlgSoftwareTimers.cpp : implementation file
//

#include "stdafx.h"
#include "Cmt66.h"
#include "DlgSoftwareTimers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DlgSoftwareTimers dialog


DlgSoftwareTimers::DlgSoftwareTimers(CWnd* pParent /*=NULL*/)
	: CDialog(DlgSoftwareTimers::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgSoftwareTimers)
	//}}AFX_DATA_INIT
}


void DlgSoftwareTimers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgSoftwareTimers)
	DDX_Control(pDX, IDC_SPINTIMER, m_SpinTimer);
	DDX_Control(pDX, IDC_EDITTIMER, m_EditTimer);
	DDX_Control(pDX, IDC_SPNUMBEROFTIMERS, m_SpinNumberOfTimers);
	DDX_Control(pDX, IDC_EDITNUMBEROFTIMERS, m_EditNumberOfTimers);
	DDX_Control(pDX, IDC_SPINTERRUPTLEVEL, m_SpinInterruptLevel);
	DDX_Control(pDX, IDC_SPGROUPLEVEL, m_SpinGroupLevel);
	DDX_Control(pDX, IDC_EDITINTERRUPTLEVEL, m_EditInterruptLevel);
	DDX_Control(pDX, IDC_EDITGROUPLEVEL, m_EditGroupLevel);
	DDX_Control(pDX, IDC_EDITCPUFREQUENCY, m_EditCpuFrequency);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgSoftwareTimers, CDialog)
	//{{AFX_MSG_MAP(DlgSoftwareTimers)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DlgSoftwareTimers message handlers

void DlgSoftwareTimers::OnOK() 
{
	// TODO: Add extra validation here

 
CWnd   *pWnd;
char    sz[256];
CString csCount, csTime, csT0IC, csT0REL, csT0;
CTime   cCurrentTime = CTime::GetCurrentTime();
int     nReload;

 pWnd=GetDlgItem(IDC_RBMILLISECONDS);
 if(pWnd) m_bMilliseconds=((CButton *)pWnd)->GetCheck();
  else m_bMilliseconds=FALSE;

 if(!GetEditBoxInt(m_nNumberOfTimers, m_EditNumberOfTimers, 2, MAXTIMERS))
  {
   MessageBeep(MB_ICONEXCLAMATION);
   MessageBox("Number of software timers is incorrect or out-of-range", "Error: Software timers code generator", MB_ICONEXCLAMATION | MB_OK);
   return;
   }

 if(!GetEditBoxInt(m_nInterruptLevel, m_EditInterruptLevel, 1, 12))
  {
   MessageBeep(MB_ICONEXCLAMATION);
   MessageBox("Interrupt level is incorrect or out-of-range", "Error: Software timers code generator", MB_ICONEXCLAMATION | MB_OK);
   return;
   }

 if(!GetEditBoxInt(m_nGroupLevel, m_EditGroupLevel, 0, 3))
  {
   MessageBeep(MB_ICONEXCLAMATION);
   MessageBox("Group level is incorrect or out-of-range", "Error: Software timers code generator", MB_ICONEXCLAMATION | MB_OK);
   return;
   }

 if(!GetEditBoxInt(m_nCpuFrequency, m_EditCpuFrequency, 1, 32000))
  {
   MessageBeep(MB_ICONEXCLAMATION);
   MessageBox("CPU frequency is incorrect or out-of-range", "Error: Software timers code generator", MB_ICONEXCLAMATION | MB_OK);
   return;
   }

// reload value for overflows every 1 millisec
// CPU clock is in KHz, prescalar is set to 8
 nReload=0x10000-(m_nCpuFrequency/8);

// --- generate SoftwareTimers.c ---
 csT0REL  = " T0REL=0x";
 wsprintf(sz, "%04X", nReload);
 csT0REL += sz;
 csT0REL += ";         // reload value determines the period\n";

 csT0  = " T0=0x";
 wsprintf(sz, "%04X", nReload);
 csT0 += sz;
 csT0 += ";            // start timer with reload value\n";

 csT0IC  =" T0IC=0x";
 wsprintf(sz, "%X;            ", m_nInterruptLevel<<2 | m_nGroupLevel | 0x40);
 csT0IC += sz;
 csT0IC +="// enable T0 interrupts, level=";
 wsprintf(sz, "%d", m_nInterruptLevel);
 csT0IC += sz;
 csT0IC += ", group=";
 wsprintf(sz, "%d\n", m_nGroupLevel);
 csT0IC += sz;

 wsprintf(sz, "%d", m_nNumberOfTimers);
 csCount=sz;

 csTime=cCurrentTime.Format("%H:%M, %A, %B %d, %Y");

 m_csCode  = "\n";
 m_csCode += "// --------------------------------------------\n";
 m_csCode += "//   generated by the Software Timers wizard\n";
 m_csCode += "//     ";
 m_csCode += csTime;
 m_csCode += "\n";
 m_csCode += "// --------------------------------------------\n";
 m_csCode += "\n";

 m_csCode += "// include \"stimers.h\" in other modules which use the software timers\n";
 m_csCode += "#include \"stimers.h\"\n";
 m_csCode += "\n"; 
 m_csCode += "// --- global variables ---\n"; 
 m_csCode += "struct SoftwareTimer ST[STCOUNT];\n"; 
 m_csCode += "\n"; 
 m_csCode += "// --------------------------------------------------------------------------\n"; 
 m_csCode += "// subroutine StInit initializes Timer0\n"; 
 m_csCode += "// --------------------------------------------------------------------------\n"; 
 m_csCode += "#pragma DebugOff\n"; 
 m_csCode += "void StInit(void){\n"; 
 m_csCode += "\n"; 
// m_csCode += " T0REL=nReload;         // reload value determines the period\n"; 
 m_csCode += csT0REL;
// m_csCode += " T0=nReload;            // start timer with reload value\n"; 
 m_csCode += csT0;
 m_csCode += "\n"; 
 m_csCode += "// --- set up the timer control register ---\n"; 
 m_csCode += " T01CON&=0xFF00;       // prescalar=8, Timer0 off\n";
// m_csCode += " T0IC=0x45;             // enable T0 interrupts - priority level=1, group=1\n"; 
 m_csCode += csT0IC;
 m_csCode += "\n"; 

 m_csCode += "// --- clear and initialize all timers ------------\n"; 
 m_csCode += " ResetSoftwareTimers();\n";
 m_csCode += "\n"; 

 m_csCode += "// --- start timer ------------\n"; 
 m_csCode += " T0R=1;                // start timer\n"; 
 m_csCode += "}\n"; 
 m_csCode += "\n"; 

 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "#pragma DebugOff\n";
 m_csCode += "void ResetSoftwareTimers(void){\n";
 m_csCode += "int n;\n";

 m_csCode += " for(n=0; n<STCOUNT; n++)\n";
 m_csCode += "  {\n";
 m_csCode += "   ST[n].uEnable=FALSE;\n";
 m_csCode += "   ST[n].ulTimeout=1;\n";
 m_csCode += "   ST[n].uExpired=FALSE;\n";
 m_csCode += "   }\n";
 m_csCode += "}\n";
 m_csCode += "\n";

 m_csCode += "// -----------------------------------------------------------------------------\n";
 m_csCode += "void StartSTimer(unsigned int nSTimer, unsigned long int ulMS){\n";
 m_csCode += "\n";
 m_csCode += " if(nSTimer >= STCOUNT) return;\n";
 m_csCode += "\n"; 
 m_csCode += " IEN = 0; // suspend interrupts while enabling softwre timers\n";
 m_csCode += "\n"; 
 m_csCode += " ST[nSTimer].uEnable=FALSE;\n";
 m_csCode += " ST[nSTimer].ulTimeout=ulMS;\n";
 m_csCode += " ST[nSTimer].uExpired=FALSE;\n";
 m_csCode += " ST[nSTimer].uEnable=TRUE;\n";
 m_csCode += "\n"; 
 m_csCode += " IEN = 1;\n";
 m_csCode += "}\n";
 m_csCode += "\n"; 

 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "// subroutine T0Isr Timer0 Interrupt Service Routine\n";
 m_csCode += "//\n";
 m_csCode += "// called upon Timer0 overflows\n";
 m_csCode += "// -----------------------------------------------------------------------------\n";
 m_csCode += "#pragma DebugOff\n";
 m_csCode += "void interrupt(0x80) T0Isr(void){\n";
 m_csCode += "int  n;\n";
 m_csCode += "\n";
 m_csCode += " for(n=0; n<STCOUNT; n++)\n";
 m_csCode += "  {\n";
 m_csCode += "   if(ST[n].uEnable)\n";
 m_csCode += "    {\n";
 m_csCode += "     if(ST[n].ulTimeout>0) ST[n].ulTimeout--;\n";
 m_csCode += "      else\n";
 m_csCode += "       {\n";
 m_csCode += "        ST[n].uExpired=TRUE;		// set the timer expired flag\n";
 m_csCode += "        ST[n].uEnable=FALSE;		// and disable the timer\n";
 m_csCode += "        }\n";
 m_csCode += "     }\n";
 m_csCode += "   }\n";
 m_csCode += "}\n";
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "// --- end of generated code ---\n";
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "\n";


// generate the header file too

 m_csHeader  = "#ifndef STIMERS_H\n";
 m_csHeader += "#define STIMERS_H\n";
 m_csHeader += "\n";
 m_csHeader += "#ifndef TRUE\n";
 m_csHeader += "#define TRUE   1\n";
 m_csHeader += "#endif\n";
 m_csHeader += "\n";
 m_csHeader += "#ifndef FALSE\n";
 m_csHeader += "#define FALSE  0\n";
 m_csHeader += "#endif\n";
 m_csHeader += "\n";
 m_csHeader += "#define EXPIRED(n)  (ST[n].uExpired)\n";
 m_csHeader += "#define ENABLE(n)   {ST[n].uEnable=1;}\n";
 m_csHeader += "#define DISABLE(n)  {ST[n].uEnable=0;}\n";
 m_csHeader += "\n";
 m_csHeader += "// --- constants ---\n";
// m_csHeader += "#define STCOUNT          8    // number of software timers\n";
 m_csHeader += "#define STCOUNT          ";
 m_csHeader += csCount;
 m_csHeader += "    // number of software timers\n";

 m_csHeader += "\n";
 m_csHeader += "predef unsigned int T0, T0REL, T01CON, T0IC;\n";
 m_csHeader += "predef unsigned bit T0R, IEN;\n";
 m_csHeader += "\n";
 m_csHeader += "// --- software timers ---\n";
 m_csHeader += "struct SoftwareTimer { unsigned int      uEnable,    // enable flag\n";
 m_csHeader += "                                         uExpired;   // becomes TRUE upon timeout\n";
 m_csHeader += "                       unsigned long int ulTimeout;  // milliseconds to timeout\n";
 m_csHeader += "                      };\n";
 m_csHeader += "\n";
 m_csHeader += "#endif\n";


	CDialog::OnOK();
}

BOOL DlgSoftwareTimers::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
CWnd *pWnd;

 m_EditCpuFrequency.SetWindowText("20000");

 m_SpinNumberOfTimers.SetRange(2, MAXTIMERS);
 m_SpinNumberOfTimers.SetPos(8);

 m_SpinTimer.SetRange(0, 7);
 m_SpinTimer.SetPos(0);

 m_SpinInterruptLevel.SetRange(1, 13);
 m_SpinInterruptLevel.SetPos(1);

 m_SpinGroupLevel.SetRange(0, 3);
 m_SpinGroupLevel.SetPos(1);

 pWnd=GetDlgItem(IDC_RBSECONDS);
 if(pWnd)
  {
   ((CButton *)pWnd)->SetCheck(FALSE);
   ((CButton *)pWnd)->EnableWindow(FALSE);
   }


 pWnd=GetDlgItem(IDC_RBMILLISECONDS);
 if(pWnd)
  {
   ((CButton *)pWnd)->SetCheck(TRUE);
   ((CButton *)pWnd)->EnableWindow(FALSE);
   }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
// --------------------------------------------------------------------------

BOOL DlgSoftwareTimers::GetEditBoxInt(int &n, CEdit &ce, int nLow, int nHigh){
CString cs;
char    *pError, sz[256]; // default max chars in an edit box

 ce.GetWindowText(cs);
 strcpy(sz, cs);
 if(cs=="") return(FALSE);
 n=(int)strtol(cs, &pError, 10);
 if(*pError) return(FALSE);
 if((n<nLow)||(n>nHigh)) return(FALSE);
 return(TRUE);
}
