// DlgStateMachine.cpp : implementation file
//

#include "stdafx.h"
#include "Cmt66.h"
#include "DlgStateMachine.h"
#include "DlgStateMachineName.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DlgStateMachine dialog


DlgStateMachine::DlgStateMachine(CWnd* pParent /*=NULL*/)
	: CDialog(DlgStateMachine::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgStateMachine)
	//}}AFX_DATA_INIT
}


void DlgStateMachine::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgStateMachine)
	DDX_Control(pDX, IDC_LBSTATES, m_LbStates);
	DDX_Control(pDX, IDC_EDITNEWSTATE, m_EditNewState);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgStateMachine, CDialog)
	//{{AFX_MSG_MAP(DlgStateMachine)
	ON_BN_CLICKED(IDC_PBNEW, OnPbNew)
	ON_WM_VKEYTOITEM()
	ON_EN_SETFOCUS(IDC_EDITNEWSTATE, OnSetfocusEditNewState)
	ON_EN_KILLFOCUS(IDC_EDITNEWSTATE, OnKillfocusEditNewState)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DlgStateMachine message handlers


/*

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

*/

BOOL DlgStateMachine::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
 m_bEditingNewState=FALSE;

 m_EditNewState.SetWindowText("");
 m_LbStates.ResetContent();
 m_LbStates.AddString("One");
 m_LbStates.AddString("Two");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DlgStateMachine::OnOK() 
{
	// TODO: Add extra validation here
int                  n;
CString              cs, csTime, csStateSpace, csState, csNextState;
CTime                cCurrentTime = CTime::GetCurrentTime();
DlgStateMachineName  Dlg;
     
 if(m_bEditingNewState) 
  {
   OnPbNew();
   return;
   }

 m_nStates=m_LbStates.GetCount();
 if(m_nStates<1)
  {
   ::MessageBeep(MB_ICONEXCLAMATION);
   MessageBox("No states defined", "Error : State Machine Wizard", MB_ICONEXCLAMATION | MB_OK);
   return;
   }

 if(Dlg.DoModal()!=IDOK) return;
 Dlg.GetStateSpaceName(csStateSpace);
 Dlg.GetStateName(csState);
 Dlg.GetNextStateName(csNextState);

// --- generate StateMachine.c ---
// header
 csTime=cCurrentTime.Format("%H:%M, %A, %B %d, %Y");

 m_csCode  = "\n";
 m_csCode += "// --------------------------------------------\n";
 m_csCode += "//   generated by the State Machine wizard\n";
 m_csCode += "//     ";
 m_csCode += csTime;
 m_csCode += "\n";
 m_csCode += "// --------------------------------------------\n";
 m_csCode += "\n";

// global variables
 m_csCode += "// -- global variables -- state information --\n";

 m_csCode += "enum STATE {";
 for(n=0; n<m_nStates-1; n++)
  {
   m_LbStates.GetText(n, cs);
   m_csCode += cs;
   m_csCode += ", ";
   }

 m_LbStates.GetText(m_nStates-1, cs);
 m_csCode += cs;
 m_csCode += "} " + csState + ", " + csNextState + ";\n";
 m_csCode += "\n"; 

// scan events
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void ScanEvents(void){\n";
 m_csCode += "// enter your code : scan inputs and set " + csNextState + "...\n";
 m_csCode += "\n";
 m_csCode += "\n";
 m_csCode += "\n";
 m_csCode += "}\n";
 m_csCode += "\n"; 

// step state machine
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void StepStateMachine(void){\n";
 m_csCode += "\n"; 
 m_csCode += "// get inputs -- this may change egNextState \n";
 m_csCode += " if(" + csNextState + "==" + csState + ") ScanEvents();\n";
 m_csCode += "\n"; 
 m_csCode += "// execute state actions\n";
 m_csCode += " if(" + csNextState + "!=" + csState + ")\n";
 m_csCode += "  {\n";
 m_csCode += "   ExitState(" + csState + ");       // leave current state\n";
 m_csCode += "   EnterState(" + csNextState + ");  // enter new state\n";
 m_csCode += "   " + csState + "=" + csNextState + ";      // update state\n";
 m_csCode += "   }\n";
 m_csCode += "  else StayInState(" + csState + "); // repeat last state\n";
 m_csCode += "}\n";
 m_csCode += "\n"; 

// chain
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void Chain(void){\n";
 m_csCode += "// enter your code : call background (idle) processes or\n";
 m_csCode += "// daisychain to other state machines...\n";
 m_csCode += "\n";
 m_csCode += "\n";
 m_csCode += "\n";
 m_csCode += "}\n";
 m_csCode += "\n";

// ExitState
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void ExitState(enum STATE es){\n";
 m_csCode += "\n";
 m_csCode += "// enter your code : call exit activity functions... \n";
 m_csCode += "\n";
 m_csCode += " switch(es)\n";
 m_csCode += "  {\n";

 for(n=0; n<m_nStates; n++)
  {
   m_LbStates.GetText(n, cs);
   m_csCode += "   case ";
   m_csCode += cs;
   m_csCode += " :\n";
   m_csCode += "              break;\n";
   }

 m_csCode += "   }\n";
 m_csCode += "}\n";
 m_csCode += "\n";

// EnterState
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void EnterState(enum STATE es){\n";
 m_csCode += "\n";
 m_csCode += "// enter your code : call entry activity functions... \n";
 m_csCode += "\n";
 m_csCode += " switch(es)\n";
 m_csCode += "  {\n";

 for(n=0; n<m_nStates; n++)
  {
   m_LbStates.GetText(n, cs);
   m_csCode += "   case ";
   m_csCode += cs;
   m_csCode += " :\n";
   m_csCode += "              break;\n";
   }

 m_csCode += "   }\n";
 m_csCode += "}\n";
 m_csCode += "\n";

// StayInState
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "void StayInState(enum STATE es){\n";
 m_csCode += "\n";
 m_csCode += "// enter your code : call activity functions... \n";
 m_csCode += "\n";
 m_csCode += " switch(es)\n";
 m_csCode += "  {\n";

 for(n=0; n<m_nStates; n++)
  {
   m_LbStates.GetText(n, cs);
   m_csCode += "   case ";
   m_csCode += cs;
   m_csCode += " :\n";
   m_csCode += "              break;\n";
   }

 m_csCode += "   }\n";
 m_csCode += "}\n";
 m_csCode += "\n";
 m_csCode += "\n"; 
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "// --- end of generated code ---\n";
 m_csCode += "// --------------------------------------------------------------------------\n";
 m_csCode += "\n";


	
	CDialog::OnOK();
}

void DlgStateMachine::OnPbNew() 
{
	// TODO: Add your control notification handler code here
CString cs;

 m_EditNewState.GetWindowText(cs);
 if(m_LbStates.FindString(-1, cs)!=LB_ERR) ::MessageBeep(MB_ICONEXCLAMATION);
  else m_LbStates.AddString(cs);
}


int DlgStateMachine::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
{
	// TODO: Add your message handler code here and/or call default
int nCurSel;

 if(nKey==VK_DELETE)
  {
   nCurSel=m_LbStates.GetCurSel();
   if(nCurSel!=LB_ERR) m_LbStates.DeleteString(nCurSel);
   }	

 return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
}

void DlgStateMachine::OnSetfocusEditNewState() 
{
	// TODO: Add your control notification handler code here
 m_bEditingNewState=TRUE;
}

void DlgStateMachine::OnKillfocusEditNewState() 
{
	// TODO: Add your control notification handler code here
 m_bEditingNewState=FALSE;
}
